"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const React = require("react");
const classnames_1 = require("classnames");
const react_pose_1 = require("react-pose");
// ================================================================================================
// Animated wrapper:
const AnimatedOverlay = react_pose_1.default.div({
    preEnter: {
        y: '10%',
        opacity: 0
    },
    enter: {
        y: 0,
        opacity: 1,
        transition: {
            duration: 300
        }
    },
    exit: {
        y: '10%',
        opacity: 0,
        delay: 0,
        staggerChildren: 0,
        transition: {
            duration: 200
        }
    }
});
exports.Overlay = React.memo(({ className, children, color, fixed, open, style }) => {
    return (React.createElement(react_pose_1.PoseGroup, { preEnterPose: "preEnter" }, open && (React.createElement(AnimatedOverlay, { className: classnames_1.default(`Overlay pin overflow-y-auto overflow-x-hidden w-full bg-${color}`, fixed ? 'fixed h-screen' : 'absolute h-full', className && className), key: "overlay", style: style }, children))));
});
exports.Overlay.defaultProps = {
    color: 'first',
    fixed: true
};
